# Extract data-tier application from specific database

# Input parameters: server and database names
Param(
  [Parameter(Position = 0, Mandatory = $true)]
  [string]$Server,
  [Parameter(Position = 1, Mandatory = $true)]
  [string]$Database
)

# Current directory 
$script_path = Split-Path -Parent $MyInvocation.MyCommand.Definition;

# Find the latest sqlpackage.exe
$last_version = 0;
for($i = 100; $i -le 190; $i += 10)
{
  $file_name = "C:\Program Files (x86)\Microsoft SQL Server\" + $i + "\DAC\bin\sqlpackage.exe";
  If (Test-Path $file_name) {
    $last_version = $i;
  }
}

# Run sqlpackage to extract DACPAC
If ($last_version -gt 0) {
  $msg = "SqlPackage version: " + $last_version;
  Write-Output $msg;
  $file_name = "C:\Program Files (x86)\Microsoft SQL Server\" + $last_version + "\DAC\bin\sqlpackage.exe";

  &$file_name `
    /Action:extract `
    /OverwriteFiles:True `
    /SourceServerName:$Server `
    /SourceDatabaseName:$Database `
    /TargetFile:$script_path\$Database.dacpac `
    /p:ExtractReferencedServerScopedElements=False
}
